# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from epilog import *
#-------------------------------------------------------------------------------
class epilog_9_21_1_13(BasisEpilog):
    scriptname = '''epilog_9_21_1_13'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType = objType_SN['device']
        instNum = self.bac_handl.h_get_testdev_inst()

        self.gcom.commit(3, {"step":0,"descr":"Starting Epilog"})


        self.gcom.commit(3, {"step":1,"descr":"Restore TD APDU-Length and Segmentation-Supported"})

        maxAPDU = self.global_dict['TD']['PropertyFeatures'][(objType,instNum,propID_SN['Max_APDU_Length_Accepted'])]['Value']
        segSupp = self.global_dict['TD']['PropertyFeatures'][(objType,instNum,propID_SN['Segmentation_Supported'])]['Value']

        self.bac_handl.h_set_td_apdu_maxapdulen( int(maxAPDU) )

        if int(segSupp) == segmentation_SN['no-segmentation']:
            self.bac_handl.h_set_td_apdu_segmentation_supported(False)
        else:
            self.bac_handl.h_set_td_apdu_segmentation_supported(True)



        return 0
        # -1 => Error, epilog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown

    #---------------------------------------------------------------------------
