# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from make_automation import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class make_7_3_1_10_2(MakeAutomation):
    scriptname = '''make_7_3_1_10_2'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']

        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        if self.make_dict['msg'] == 2:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })

            self.gcom.commit(3, {"step":1,"descr":"Set Event_Enable to (T,T,T)"})
            self.bac_handl.t_write_property( objType, instNum, propID_SN['Event_Enable'], '(T,T,T)' )

            return {'answer':'1'}


        elif self.make_dict['msg'] == 3:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })
            myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


            self.gcom.commit(3, {"step":1,"descr":"Enable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')


            nCount = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Notification_Threshold']) )
            self.gcom.commit(3, {"step":2,"descr":"Generate %d-3 Records"%( nCount ) })
            #LogEnable and LogDisable generate 2 records, buffer-purge 1 record, so we just need to create X-3 records

            nCount -= 3
            myIUT.generate_log_object_records(2, objType, instNum, nCount)


            self.gcom.commit(3, {"step":3,"descr":"Disable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}


        elif self.make_dict['msg'] == 7 and self.make_dict['substep'] == 1:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d-%d ..."%( self.make_dict['msg'], self.make_dict['substep'] ) })

            self.gcom.commit(3, {"step":1,"descr":"Set Event_Enable to (T,T,F)"})
            self.bac_handl.t_write_property( objType, instNum, propID_SN['Event_Enable'], '(T,T,F)' )

            return {'answer':'1'}


        elif self.make_dict['msg'] == 7 and self.make_dict['substep'] == 2:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d-%d ..."%( self.make_dict['msg'], self.make_dict['substep'] ) })
            myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


            self.gcom.commit(3, {"step":1,"descr":"Enable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')


            nCount = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Notification_Threshold']) )
            self.gcom.commit(3, {"step":2,"descr":"Generate %d-2 Records"%( nCount ) })
            #LogEnable and LogDisable generate 2 records, so we just need to create X-2 records

            nCount -= 2
            myIUT.generate_log_object_records(2, objType, instNum, nCount)


            self.gcom.commit(3, {"step":3,"descr":"Disable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}


        elif self.make_dict['msg'] == 7 and self.make_dict['substep'] == 3:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d-%d ..."%( self.make_dict['msg'], self.make_dict['substep'] ) })

            self.gcom.commit(3, {"step":1,"descr":"Set Event_Enable to (T,T,T)"})
            self.bac_handl.t_write_property( objType, instNum, propID_SN['Event_Enable'], '(T,T,T)' )

            return {'answer':'1'}


        elif (self.make_dict['msg'] == 8 and self.make_dict['substep'] == 1) \
        or (self.make_dict['msg'] == 10 and self.make_dict['substep'] == 1):

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d-%d ..."%( self.make_dict['msg'], self.make_dict['substep'] ) })

            if objType == objType_SN['trend-log']:

                self.gcom.commit(3, {"step":1,"descr":"Set invalid Log_DeviceObjectProperty"})
                szObjectPropertyReference = '((analog-output,4711),present-value,-,-)'
                self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

            elif objType == objType_SN['trend-log-multiple']:

                self.gcom.commit(3, {"step":1,"descr":"Set invalid Log_DeviceObjectProperty"})
                szObjectPropertyReference = '('
                szObjectPropertyReference += '((analog-output,4711),present-value,-,-)'
                szObjectPropertyReference += ')'
                self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

            else:
                return {}

            self.gcom.commit(3, {"step":2,"descr":"Ebable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')

            self.gcom.commit(3, {"step":3,"descr":"Wait FailTime"})
            time.sleep(5)

            self.gcom.commit(3, {"step":4,"descr":"Disable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}


        elif (self.make_dict['msg'] == 8 and self.make_dict['substep'] == 3) \
        or (self.make_dict['msg'] == 10 and self.make_dict['substep'] == 2):

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d-%d ..."%( self.make_dict['msg'], self.make_dict['substep'] ) })

            if objType == objType_SN['trend-log']:

                self.gcom.commit(3, {"step":1,"descr":"Set valid Log_DeviceObjectProperty"})
                szObjectPropertyReference = '((analog-output,1),present-value,-,-)'
                self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

            elif objType == objType_SN['trend-log-multiple']:

                self.gcom.commit(3, {"step":1,"descr":"Set valid Log_DeviceObjectProperty"})
                szObjectPropertyReference = '('
                szObjectPropertyReference += '((analog-output,1),present-value,-,-)'
                szObjectPropertyReference += ')'
                self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

            else:
                return {}

            self.gcom.commit(3, {"step":2,"descr":"Ebable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')

            self.gcom.commit(3, {"step":3,"descr":"Wait FailTime"})
            time.sleep(5)

            self.gcom.commit(3, {"step":4,"descr":"Disable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}


        elif self.make_dict['msg'] == 9:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })

            self.gcom.commit(3, {"step":1,"descr":"Set Event_Enable to (T,F,T)"})
            self.bac_handl.t_write_property( objType, instNum, propID_SN['Event_Enable'], '(T,F,T)' )

            return {'answer':'1'}






        return {}
        # On Error: return -1 or raise Exception
        #       -> test will abort and fail
        #
        # On SUCCESS: return {'answer':'1'}
        #       -> test continues with success
        #
        # On FAILURE: return {'answer':'0'}
        #       -> test continues or aborts (depends on test)
        #
        # No SUCCESS or invalid Step-number: return {}
        #       -> MAKE will pop up for manual user interaction
        #

    #---------------------------------------------------------------------------
