# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from make_automation import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class make_7_3_2_24_18(MakeAutomation):
    scriptname = '''make_7_3_2_24_18'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']

        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        if self.make_dict['msg'] == 3:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })
            myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


            nCount = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Notification_Threshold']) )
            #buffer-purge will generate 1 record (within test), so we just need to create X-1 records
            self.gcom.commit(3, {"step":1,"descr":"Generate %d-1 Records"%( nCount ) })

            nCount -= 1
            myIUT.generate_log_object_records(1, objType, instNum, nCount)


            return {'answer':'1'}



        elif self.make_dict['msg'] == 6:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })
            myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


            nCount = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Notification_Threshold']) )
            #N records, such that N  < Notification_Threshold - 1)
            self.gcom.commit(3, {"step":1,"descr":"Generate %d-2 Records"%( nCount ) })

            nCount -= 2
            myIUT.generate_log_object_records(1, objType, instNum, nCount)


            return {'answer':'1'}




        return {}
        # On Error: return -1 or raise Exception
        #       -> test will abort and fail
        #
        # On SUCCESS: return {'answer':'1'}
        #       -> test continues with success
        #
        # On FAILURE: return {'answer':'0'}
        #       -> test continues or aborts (depends on test)
        #
        # No SUCCESS or invalid Step-number: return {}
        #       -> MAKE will pop up for manual user interaction
        #

    #---------------------------------------------------------------------------
