# /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from make_automation import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class make_mbs_7_3_2_24_10(MakeAutomation):
    scriptname = '''make_mbs_7_3_2_24_10'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']

        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        if self.make_dict['msg'] == 5:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })
            myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


            self.gcom.commit(3, {"step":1,"descr":"Enable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')


            nCount = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Notification_Threshold']) )
            #LogEnable and LogDisable generate 2 records, buffer-purge 1 record, so we just need to create X-3 records
            self.gcom.commit(3, {"step":2,"descr":"Generate %d-3 Records"%( nCount ) })

            nCount -= 3
            myIUT.generate_log_object_records(2, objType, instNum, nCount)


            self.gcom.commit(3, {"step":3,"descr":"Disable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}


        if self.make_dict['msg'] == 9:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })
            myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


            self.gcom.commit(3, {"step":1,"descr":"Enable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')

            #until Total_Record_Count == Y1 + Notification_Threshold
            Y1 = self.make_dict['test_data']['Y1']
            NT = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Notification_Threshold']) )
            TRC = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Total_Record_Count']) )
            nCount = nCount = NT - (TRC - Y1)
            #1 record will be generated by the log-disable
            self.gcom.commit(3, {"step":2,"descr":"Generate %d-1 Records"%( nCount ) })

            nCount -= 1
            myIUT.generate_log_object_records(2, objType, instNum, nCount)


            self.gcom.commit(3, {"step":3,"descr":"Disable Log"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}


        return {}
        # On Error: return -1 or raise Exception
        #       -> test will abort and fail
        #
        # On SUCCESS: return {'answer':'1'}
        #       -> test continues with success
        #
        # On FAILURE: return {'answer':'0'}
        #       -> test continues or aborts (depends on test)
        #
        # No SUCCESS or invalid Step-number: return {}
        #       -> MAKE will pop up for manual user interaction
        #

    #---------------------------------------------------------------------------
