# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class prolog_7_3_2_24_17(BasisProlog):
    scriptname = '''prolog_7_3_2_24_17'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']
        bConfirmed = True


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})
        myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


        self.gcom.commit(3, {"step":1,"descr":"Initialize Log-object for alarming"})
        myIUT.initialize_log_object_for_alarming(1, objType, instNum)


        self.gcom.commit(3, {"step":2,"descr":"Check if object is in a NORMAL state"})
        ES = int( self.bac_handl.t_read_property( objType, instNum, propID_SN['Event_State'] ) )
        if ES != event_state_SN['normal']:
            self.gcom.commit(3, {"step":2,'substep':1,"descr":"Set object into a Normal condition"})
            self.bac_handl.h_change_iut_object_event_state(objType, instNum, event_state_SN['normal'])


        self.gcom.commit(3, {"step":3,"descr":"Acknowledge Transitions"})
        self.bac_handl.h_acknowledge_transitions(objType, instNum)


        self.gcom.commit(3, {"step":4,"descr":"Add TD to IUTs Recipient_List"})
        NC = int( self.bac_handl.t_read_property( objType, instNum, propID_SN['Notification_Class'] ) )
        self.bac_handl.h_register_in_notification_class( NC, conf=bConfirmed )





        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------