# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class prolog_9_21_1_4_1(BasisProlog):
    scriptname = '''prolog_9_21_1_4_1'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']
        count = self.private_dict['count']

        nCount = abs( count )


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})
        myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


        self.gcom.commit(3, {"step":1,"descr":"Initialize Log-object"})
        myIUT.initialize_log_object(1, objType, instNum)


        self.gcom.commit(3, {"step":2,"descr":"Enable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')


        self.gcom.commit(3, {"step":3,"descr":"Generate at least %d Records"%nCount })
        RC_before = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Record_Count']) )

        nCount += 2
        myIUT.generate_log_object_records(3, objType, instNum, nCount)


        self.gcom.commit(3, {"step":4,"descr":"Disable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


        #some FailTime
        time.sleep( 2 )


        RC_after = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Record_Count']) )
        if not RC_after-1 > RC_before:
            self.gcom.commit(6,{'description':'%s,%d has no logDatum records (Record_Count %d vs %d)!'%( objType_NS[objType],instNum, RC_after,RC_before) })
            return 1




        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------