# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class prolog_mbs_7_3_2_24_5_external(BasisProlog):
    scriptname = '''prolog_mbs_7_3_2_24_5_external'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']
        bUseCovP = self.private_dict['useCovP']


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})
        myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


        self.gcom.commit(3, {"step":1,"descr":"Set TD ServicesSupported"})
        self.bac_handl.h_set_td_services_supported_bit(services_supported_bit_SN['subscribeCOV'], True)
        if bUseCovP:
            self.bac_handl.h_set_td_services_supported_bit(services_supported_bit_SN['subscribeCOVProperty'], True)


        self.gcom.commit(3, {"step":2,"descr":"Initialize Log-object"})
        myIUT.initialize_log_object(2, objType, instNum, True)


        if objType == objType_SN['trend-log']:

            self.gcom.commit(3, {"step":3,"descr":"Set Logging_Type to COV"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Logging_Type'], logging_type_SN['cov'])


            self.gcom.commit(3, {"step":4,"descr":"Set COV_Resubscription_Interval to 60 seconds"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['COV_Resubscription_Interval'],'60')


            self.gcom.commit(3, {"step":5,"descr":"Set Log_DeviceObjectProperty"})
            if bUseCovP:
                szObjectPropertyReference = '((analog-output,1),high-limit,-,(8,%d))'%( self.bac_handl.h_get_testdev_inst() )
            else:
                szObjectPropertyReference = '((analog-output,1),present-value,-,(8,%d))'%( self.bac_handl.h_get_testdev_inst() )
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

        else:
            return 1


        self.gcom.commit(3, {"step":6,"descr":"Enable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')



        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------