# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class prolog_mbs_7_3_2_24_7(BasisProlog):
    scriptname = '''prolog_mbs_7_3_2_24_7'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})
        myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


        self.gcom.commit(3, {"step":1,"descr":"Initialize Log-object"})
        myIUT.initialize_log_object(1, objType, instNum)


        self.gcom.commit(3, {"step":2,"descr":"Set Buffer_Size to 20"})
        if self.global_dict['IUT']['PropertyFeatures'].is_writeable(objType, instNum, propID_SN['Buffer_Size']):
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Buffer_Size'], '20')


        self.gcom.commit(3, {"step":3,"descr":"Enable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')




        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------