# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
#-------------------------------------------------------------------------------
class prolog_mbs_9_21_1_1(BasisProlog):
    scriptname = '''prolog_mbs_9_21_1_1'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})


        self.gcom.commit(3, {"step":1,"descr":"Disable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


        self.gcom.commit(3, {"step":2,"descr":"Purge Buffer"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Record_Count'], '0')


        self.gcom.commit(3, {"step":3,"descr":"Set Start_Time"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Start_Time'], '((*,*-*-*),*:*:*.*)')


        self.gcom.commit(3, {"step":4,"descr":"Set Stop_Time"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Stop_Time'], '((*,*-*-*),*:*:*.*)')


        if self.global_dict['IUT']['PropertyFeatures'].is_writeable(objType, instNum, propID_SN['Stop_When_Full']):
            self.gcom.commit(3, {"step":5,"descr":"Set Stop_When_Full to False"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Stop_When_Full'], 'False')


        if self.global_dict['IUT']['PropertyFeatures'].is_writeable(objType, instNum, propID_SN['Buffer_Size']):
            self.gcom.commit(3, {"step":6,"descr":"Set Buffer_Size to 20"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Buffer_Size'], '20')


        if self.global_dict['IUT']['PropertyFeatures'].has_object_property(objType, instNum, propID_SN['Logging_Type']) \
        and self.global_dict['IUT']['PropertyFeatures'].is_writeable(objType, instNum, propID_SN['Logging_Type']):
            self.gcom.commit(3, {"step":7,"descr":"Set Logging_Type to Polled"})
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Logging_Type'], '0')


        self.gcom.commit(3, {"step":8,"descr":"Set Log_Interval to 500"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_Interval'], '500')


        self.gcom.commit(3, {"step":9,"descr":"Set Log_DeviceObjectProperty"})
        szObjectPropertyReference = '((analog-input,1),present-value,-,-)'
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)


        self.gcom.commit(3, {"step":10,"descr":"Set local Date and Time"})
        self.bac_handl.t_time_sync()


        self.gcom.commit(3, {"step":11,"descr":"Enable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')


        self.gcom.commit(3, {"step":12,"descr":"Generate 4-10 Records"})

        RC_before = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Record_Count']) )

        # generate at least 4 records
        if objType == objType_SN['trend-log']:

            if not self.global_dict['IUT']['PropertyFeatures'].has_object_property(objType, instNum, propID_SN['Logging_Type']):
                LI = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Log_Interval']) )
                if LI == 0:
                    LT = logging_type_SN['cov']
                else:
                    LT = logging_type_SN['polled']
            else:
                LT = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Logging_Type']) )

            if LT == logging_type_SN['polled']:
                LI = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Log_Interval']) )
                LI /= 100
                self.gcom.commit(3, {"step":12,"substep":1,"descr":"Wait 10*Log_Interval (%d seconds)"%( 10*LI ) })
                time.sleep( LI*10 )

            elif LT == logging_type_SN['cov']:
                prop = self.bac_handl.t_read_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'])
                (ref_objType, ref_instNum), ref_propID, ref_index, ref_devID = prop.get_BACNET_DEVICE_OBJECT_PROPERTY_REFERENCE_value()
                #check if reference is internal object and writeable
                if ref_devID != None and ref_devID[1] != self.bac_handl.rem_inst:
                    return -1
                self.global_dict['IUT']['PropertyFeatures'].is_writeable(ref_objType, ref_instNum, ref_propID, True)
                for idx in range(0,10):
                    self.gcom.commit(3, {"step":12,"substep":idx,"descr":"Change Value"})
                    oldValue = self.bac_handl.t_read_property(ref_objType, ref_instNum, ref_propID)
                    newValue = self.bac_handl.h_get_another_value(ref_objType, ref_instNum, ref_propID, str(oldValue), self.global_dict['IUT']['PropertyFeatures'])
                    self.bac_handl.t_write_property(ref_objType, ref_instNum, ref_propID, newValue)
                    time.sleep( 2 )

            elif LT == logging_type_SN['triggered']:
                for idx in range(0,10):
                    self.gcom.commit(3, {"step":12,"substep":idx,"descr":"Set Trigger"})
                    self.bac_handl.t_write_property(objType, instNum, propID_SN['Trigger'], 'True')
                    time.sleep( 2 )

            else:
                self.gcom.commit(6,{'description':'%s,%d has invalid LoggingType %d'%( objType_NS[objType],instNum, LT) })
                return -1


        else:
            raise BacTestNotSupported, 'Invalid objectType %s'%( objType_NS[objType] )


        self.gcom.commit(3, {"step":13,"descr":"Disable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


        #some FailTime
        time.sleep( 2 )


        RC_after = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Record_Count']) )
        if not RC_after-1 > RC_before:
            self.gcom.commit(6,{'description':'%s,%d has no logDatum records (Record_Count %d vs %d)!'%( objType_NS[objType],instNum, RC_after,RC_before) })
            return 1


        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------