# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
from user_mbs_iut_module import IUTClass
#-------------------------------------------------------------------------------
class prolog_mbs_9_21_1_1_external_REAL(BasisProlog):
    scriptname = '''prolog_mbs_9_21_1_1_external_REAL'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType, instNum = self.private_dict['objID']

        nCount = 10


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})
        myIUT = IUTClass(self.bac_handl, self.gcom, self.global_dict)


        self.gcom.commit(3, {"step":1,"descr":"Initialize Log-object"})
        myIUT.initialize_log_object(1, objType, instNum, True)


        if objType == objType_SN['trend-log']:

            self.gcom.commit(3, {"step":2,"descr":"Set Log_DeviceObjectProperty with external REAL properties"})
            #set 1 external REAL reference
            szObjectPropertyReference = '((analog-input,1),present-value,-,(8,%d))'%( self.bac_handl.h_get_testdev_inst() )
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

        elif objType == objType_SN['trend-log-multiple']:

            self.gcom.commit(3, {"step":2,"descr":"Set Log_DeviceObjectProperty with external REAL properties"})
            #set 10 external REAL references
            szObjectPropertyReference = '('
            szObjectPropertyReference += '((analog-input,1),present-value,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((analog-output,1),present-value,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((analog-value,1),present-value,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((analog-input,1),high-limit,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((analog-value,1),low-limit,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((analog-output,1),resolution,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((loop,1),present-value,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((averaging,1),average-value,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((averaging,1),maximum-value,-,(8,%d)),'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += '((pulse-converter,1),present-value,-,(8,%d))'%( self.bac_handl.h_get_testdev_inst() )
            szObjectPropertyReference += ')'
            self.bac_handl.t_write_property(objType, instNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)

        else:
            raise BacTestNotSupported, 'Invalid objectType %s'%( objType_NS[objType] )


        self.gcom.commit(3, {"step":3,"descr":"Enable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'True')


        self.gcom.commit(3, {"step":4,"descr":"Generate at least %d Records"%nCount })
        RC_before = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Record_Count']) )

        myIUT.generate_log_object_external_records(3, objType, instNum, nCount)


        self.gcom.commit(3, {"step":5,"descr":"Disable Log"})
        self.bac_handl.t_write_property(objType, instNum, propID_SN['Enable'], 'False')


        #some FailTime
        time.sleep( 2 )


        RC_after = int( self.bac_handl.t_read_property(objType, instNum, propID_SN['Record_Count']) )
        if not RC_after-1 > RC_before:
            self.gcom.commit(6,{'description':'%s,%d has no logDatum records (Record_Count %d vs %d)!'%( objType_NS[objType],instNum, RC_after,RC_before) })
            return 1




        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------